require 'spec_helper'

describe String do
	describe '#word_count' do
		it 'should have a method called word_count' do
			should respond_to :word_count
		end

		it 'should return 1 when the string is one word long' do
			a_string = 'Apple'
			expect(a_string.word_count).to eq 1
		end

		it 'should return 0 when the string is blank' do
			a_string = ''
			expect(a_string.word_count).to eq 0
		end

		it 'should return 4 when the string is 4 words long' do
			a_string = 'An apple and banana'
			expect(a_string.word_count).to eq 4
		end

		it 'should return 3 when the string is 3 words repeated' do
			a_string = 'apple apple apple'
			expect(a_string.word_count).to eq 3
		end
	end

	describe '#unique_words' do
		it 'should return an array containing the word when the string is only one word long' do
			a_string = "Apple"
			expect(a_string.unique_words).to eq ['Apple']
		end

		it 'should return an array containing one word when the string repeats the same word' do
			a_string = "apple apple apple"
			expect(a_string.unique_words).to eq ['apple']
		end

		it 'should return an array containing unique words when different words are in the string' do
			a_string = "apple banana orange"
			expect(a_string.unique_words).to eq ['apple', 'banana', 'orange']
		end
	end

	describe '#unique_words_count' do
		it 'should return 1 when the string is one word long' do
			a_string = 'Apple'
			expect(a_string.unique_words_count).to eq 1
		end

		it 'should return 0 when the string is blank' do
			a_string = ''
			expect(a_string.unique_words_count).to eq 0
		end

		it 'should return 4 when the string is 4 unique words long' do
			a_string = 'An apple and banana'
			expect(a_string.unique_words_count).to eq 4
		end

		it 'should return 1 when the string is 3 words repeated' do
			a_string = 'apple apple apple'
			expect(a_string.unique_words_count).to eq 1
		end
	end
end
